<script type="text/html" data-help-name="dim-xml-params-server">
  <style>
    tr:nth-child(even) {background-color: #f8f8f8;}
    tr:nth-child(odd) {background-color: #e8e8e8;}
  </style>
  <p>
    A DIM-XML Server node providing a Parameters service that describes a set
    of parameters organized as an array.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object | array</span></dt>
    <dd>
      The input value(s) that can update the parameter(s).<br>
      If this property is not set, nothing will be changed.
    </dd>
  </dl>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">array</span></dt>
    <dd>
      The updated service value(s) sent to subscribed clients.<br>
      For details, see <code>DIM-XML Params Client</code> node.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node registers a <i>Parameters</i> service on a DIM Name Server (DNS).
    A connection to the DNS Server is required for this purpose, which can be
    created by clicking on the pencil icon or selecting an existing one shared
    between several DIM-XML nodes.
  </p>
  <p>
    The service is identified by the <i>Service Name</i> which must be unique
    for a given DNS Server and comply the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
    <pre><b>part *( "/" part )</b>
      <br>part = (ALPHA / DIGIT) *body
      <br>body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")</pre>
    For example:
    <pre>/params/service/name</pre>
  </p>
  <p>
    Parameters can be defined using the <i>Parameters</i> list, ordered by
    index. Whenever a new parameter is added, the <b>Index</b> field is
    pre-filled with the consecutive integer of the maximum index, but it can
    be edited.<br>
    Each parameter can be described using the <b>Name</b> field and shall
    have one of the following value types:
    <table style="outline-width:#888 solid thin;text-align:left">
      <tr style="background-color: #e6e6e6;">
        <th width="70px">Type</th><th width="180px">Value</th>
      </tr>
      <tr><td>uint8</td><td>8 bits unsigned integer</td></tr>
      <tr><td>uint16</td><td>16 bits unsigned integer</td></tr>
      <tr><td>uint32</td><td>32 bits unsigned integer</td></tr>
      <tr><td>uint64</td><td>64 bits unsigned integer</td></tr>
      <tr><td>int8</td><td>8 bits signed integer</td></tr>
      <tr><td>int16</td><td>16 bits signed integer</td></tr>
      <tr><td>int32</td><td>32 bits signed integer</td></tr>
      <tr><td>int64</td><td>64 bits signed integer</td></tr>
      <tr><td>float</td><td>32 bits floating point number</td></tr>
      <tr><td>double</td><td>64 bits floating point number</td></tr>
      <tr><td>string</td><td>String</td></tr>
      <tr><td>enum</td><td>Enumerated type</td></tr>
      <tr><td>bool</td><td>Boolean (0/1) value</td></tr>
      <tr><td>nested</td><td>Nested parameters</td></tr>
    </table>
    The definition of <i>enum</i> and <i>nested</i> parameter is done by means
    of a dedicated editor by clicking on the option button (three dots).<br>
    Also, for all types except <i>nested</i>, it is possible to specify the
    <b>Unit</b> of the value.
  </p>
  <p>
    The input value(s) must have the following properties to update parameter(s):
    <ul>
      <li>
        <code>index</code>, the integer identifying the parameter to update.
      </li>
      <li>
        <code>value</code>, the parameter value to set.
      </li>
    </ul>
    The index must refer to one of the parameters in the set of parameters
    and the value must comply the specified value type, otherwise the input
    value is ignored.
  </p>
  <p>
    Below are some examples of input value(s):
    <ul>
      <li>
        to update a single parameter:
        <pre>{ index: 0, value: 1500 }</pre>
      </li>
      <li>
        to update more parameters:
        <pre>[ { index: 2, value: true }, { index: 4, value: 1.2 } ]</pre>
      </li>
      <li>
        to update a <i>nested</i> parameter:
        <pre>{ index: 5, value: [ { index: 1, value: 3 } ] }</pre>
      </li>
    </ul>
  </p>
</script>
